(in-package :it.bese.ucw-user)

(defvar *hello-application*
  (make-instance 'cookie-session-application :url-prefix "/hello/"
   :www-roots 
   (list 
      ;; The app-specific wwwroot is here:
      (merge-pathnames *ucw-applications-directory*)
      ;; and default files may be found in the standard wwwroot 
      (merge-pathnames (make-pathname :directory '(:relative "wwwroot"))
		   (asdf:component-pathname (asdf:find-system :ucw))))))

;; If you have the 'alt-url-prefix' extension and you want to use it,
;; then it is enabled like this:
;;(setf (server.search-alt-url-base *default-server*) t)
;; Now static files will be searched in the "usual" places (i.e., at '/'), too,
;; instead of using the '/hello/' url prefix. This new url prefix will be used
;; for each of the wwwroots specified above.
;; This option can also be set when creating the server. (See start.lisp.)

(register-application *default-server* *hello-application*)

;; for some reason this function will not be found if it is renamed 'valid'.
(defun valid? (name)
  (> (length name) 0))

(defentry-point "index.ucw" (:application *hello-application*) ()
  (loop
     (let ((name (call 'hello-world-home-page)))
       (and (valid? name)
	    (call 'personalized-greeting :name name)))))


(defentry-point "index_inverse.ucw" (:application *hello-application*) ()
  (let ((name "calm, generous, and faithful friend"))
     (loop
	 (call 'personalized-greeting :name name)
	 (loop while (not (valid? (setq name (call 'hello-world-home-page))))))))


(defentry-point "index_simple.ucw" (:application *hello-application*) ()
  (loop
     (let ((name (call 'hello-world-home-page)))
       (call 'personalized-greeting :name name))))


(defcomponent hello-world-home-page (simple-window-component)
  ()
  (:default-initargs :title "Hello, World!"
   :javascript '((:src "dojo.js"))))

    
#|
(defcomponent hello-world (simple-window-component) ()
              (:default-initargs :title "hi"
              :stylesheet '("stylesheet.css" "stylesheet2.css")
              :content-type "text/html; charset=utf-8;"
              ;:javascript '((:src "dojo.js")
              ;              (:js (dojo.require "dojo.event.*"))
              ;              (:script "var foo = 3;"))
	      )
              (:entry-point "hello.ucw" 
			    (:application *hello-application* 
			     :class url-dispatcher))
              (:render () (<:as-html "hello world")))
|#    

(defmethod render ((hello hello-world-home-page))
  (<:p "Hello, World!")
  (let ((name ""))
    (<ucw:form
     :action (ok hello name)
     (<ucw:input :type "text" :accessor name)
     (<:submit))))

(defcomponent personalized-greeting (simple-window-component)
  ((name :accessor name :initarg :name))
  (:default-initargs :title "Greetings!"
   :javascript '((:src "dojo.js"))))

(defmethod render ((greeting personalized-greeting))
  (<:p "Hi, " (<:as-html (name greeting)) ", how are you?")
  (<ucw:a :action (ok greeting) "Done."))


